<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="bookingOrderInfoId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <BookingOrderInfoEdit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import BookingOrderInfoEdit from './components/bookingOrderInfoEdit.vue';
  import { pageBookingOrderInfo, removeBookingOrderInfo, removeBatchBookingOrderInfo } from '@/api/booking/bookingOrderInfo';
  import type { BookingOrderInfo, BookingOrderInfoParam } from '@/api/booking/bookingOrderInfo/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<BookingOrderInfo[]>([]);
  // 当前编辑数据
  const current = ref<BookingOrderInfo | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageBookingOrderInfo({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '',
      dataIndex: 'id',
      key: 'id',
      align: 'center',
      width: 90,
    },
    {
      title: '关联订单表id',
      dataIndex: 'oid',
      key: 'oid',
      align: 'center',
    },
    {
      title: '关联场馆id',
      dataIndex: 'sid',
      key: 'sid',
      align: 'center',
    },
    {
      title: '关联场地id',
      dataIndex: 'fid',
      key: 'fid',
      align: 'center',
    },
    {
      title: '场馆',
      dataIndex: 'siteName',
      key: 'siteName',
      align: 'center',
    },
    {
      title: '场地',
      dataIndex: 'fieldName',
      key: 'fieldName',
      align: 'center',
    },
    {
      title: '预约时间段',
      dataIndex: 'dateTime',
      key: 'dateTime',
      align: 'center',
    },
    {
      title: '单价',
      dataIndex: 'price',
      key: 'price',
      align: 'center',
    },
    {
      title: '儿童价',
      dataIndex: 'childrenPrice',
      key: 'childrenPrice',
      align: 'center',
    },
    {
      title: '成人人数',
      dataIndex: 'adultNum',
      key: 'adultNum',
      align: 'center',
    },
    {
      title: '儿童人数',
      dataIndex: 'childrenNum',
      key: 'childrenNum',
      align: 'center',
    },
    {
      title: '1已付款，2未付款，3无需付款或占用状态',
      dataIndex: 'payStatus',
      key: 'payStatus',
      align: 'center',
    },
    {
      title: '是否免费：1免费、2收费',
      dataIndex: 'isFree',
      key: 'isFree',
      align: 'center',
    },
    {
      title: '是否支持儿童票：1支持，2不支持',
      dataIndex: 'isChildren',
      key: 'isChildren',
      align: 'center',
    },
    {
      title: '预订类型：1全场，2半场',
      dataIndex: 'type',
      key: 'type',
      align: 'center',
    },
    {
      title: '组合数据:日期+时间段+场馆id+场地id',
      dataIndex: 'mergeData',
      key: 'mergeData',
      align: 'center',
    },
    {
      title: '开场时间',
      dataIndex: 'startTime',
      key: 'startTime',
      align: 'center',
    },
    {
      title: '下单时间',
      dataIndex: 'orderTime',
      key: 'orderTime',
      align: 'center',
    },
    {
      title: '毫秒时间戳',
      dataIndex: 'timeFlag',
      key: 'timeFlag',
      align: 'center',
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: BookingOrderInfoParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: BookingOrderInfo) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: BookingOrderInfo) => {
    const hide = message.loading('请求中..', 0);
    removeBookingOrderInfo(row.bookingOrderInfoId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchBookingOrderInfo(selection.value.map((d) => d.bookingOrderInfoId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: BookingOrderInfo) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'BookingOrderInfo'
  };
</script>

<style lang="less" scoped></style>
